/*-
 * Copyright 2008 Jason Harmening
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef __CX88_FFMPEG_CAPTURE_H__
#define __CX88_FFMPEG_CAPTURE_H__

extern "C"
{
   #include <ffmpeg/swscale.h>
};

#include "cx88_file_capture.h"

class cx88_ffmpeg_capture
   : public cx88_file_capture
{
   public:
      cx88_ffmpeg_capture(const char *filename, int &error);
      
      virtual ~cx88_ffmpeg_capture(void);
      
   protected:
      
      virtual void process_buffer(void *data, size_t num_bytes, size_t packet_size = 0);
      
      virtual int initialize(cx88_capture_config *conf);
      
   private:
      
      uint8_t *m_buffers[3];
      int m_src_linesize[3];
      int m_src_lines[3];
      int m_dst_linesize[3];
      int m_dst_lines[3];

      struct SwsContext *m_context;
      
};

#endif
