/*-
 * Copyright 2010 Jason Harmening
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
 
#ifndef __CX23885_AVCORE_H__
#define __CX23885_AVCORE_H__

#include "cx88_common_ioctl.h"

typedef enum
{
   CX23885AV_VIDEO_PATH1 = 0,
   CX23885AV_VIDEO_PATH2,
   CX23885AV_VIDEO_PATH3,
   CX23885AV_NUM_VIDEO_PATHS
} cx23885_avcore_video_path_t;

typedef enum 
{
   CX23885AV_AUDIO_PATH1 = 0,
   CX23885AV_AUDIO_PATH2,
   CX23885AV_NUM_AUDIO_PATHS
} cx23885_avcore_audio_path_t;

int cx23885av_gpioctl(device_t dev, cx88_common_gpio *gpio);
int cx23885av_set_adc(device_t dev, device_t adc);
int cx23885av_dif_enable(device_t dev, cx23888_dif_control *control);
int cx23885av_dif_disable(device_t dev);

#define CX23885AV_DRIVER_NAME  "cx23885av"
#define CX23885ADC_DRIVER_NAME "cx23885adc"

#define CX23885AV_MINVER 1
#define CX23885AV_MODVER 1
#define CX23885AV_MAXVER 1

#define CX23885ADC_MINVER 1
#define CX23885ADC_MODVER 1
#define CX23885ADC_MAXVER 1

#endif
