/*-
 * Copyright 2007 Jason Harmening
 * 
 * Copyright 2009 Konstantin Dimitrov <kosio.dimitrov@gmail.com>
 * Add register definitions for CX23885/7/8
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef __CX88_MPEG_REGS_H__
#define __CX88_MPEG_REGS_H__

#define CX23880_MPEG_REG_PTR1                    0x30009C

#define CX23880_MPEG_REG_PTR2                    0x3000DC

#define CX23880_MPEG_REG_CNT1                    0x30011C

#define CX23880_MPEG_REG_CNT2                    0x30015C

#define CX23885_VIDEO_B_REG_GP_COUNT             0x130120
#define CX23885_VIDEO_C_REG_GP_COUNT             0x130220
#define CX23880_MPEG_REG_GP_COUNT                0x33C020

#define CX23885_VIDEO_B_REG_GP_COUNT_CONTROL     0x130130
#define CX23885_VIDEO_C_REG_GP_COUNT_CONTROL     0x130230
#define CX23880_MPEG_REG_GP_COUNT_CONTROL        0x33C030

#define CX23885_VIDEO_B_REG_DMA_CONTROL          0x130140
#define CX23885_VIDEO_C_REG_DMA_CONTROL          0x130240
#define CX23880_MPEG_REG_DMA_CONTROL             0x33C040
#define MPEG_RISC_ENABLE                         (1 << 4)
#define MPEG_FIFO_ENABLE                         (1 << 0)

#define CX23880_MPEG_REG_XFER_STATUS             0x33C044

#define CX23885_VIDEO_B_REG_LINE_LENGTH          0x130150
#define CX23885_VIDEO_C_REG_LINE_LENGTH          0x130250
#define CX23880_MPEG_REG_LINE_LENGTH             0x33C048

#define CX23885_VIDEO_B_REG_SOP_CONTROL          0x130154
#define CX23885_VIDEO_C_REG_SOP_CONTROL          0x130254
#define CX23880_MPEG_REG_SOP_CONTROL             0x33C04C
#define MPEG_SOP_START_BYTE                      0xFF,16
#define MPEG_SOP_PACKET_LENGTH                   0xFFF,4
#define MPEG_SOP_START_COUNT                     0xF,0

#define CX23885_VIDEO_B_REG_GEN_CONTROL          0x130158
#define CX23885_VIDEO_C_REG_GEN_CONTROL          0x130258
#define CX23880_MPEG_REG_GEN_CONTROL             0x33C050
#define MPEG_GEN_IN_SYNC                         (1 << 0)
#define MPEG_GEN_POSEDGE                         (1 << 1)
#define MPEG_GEN_PUNC_CLK                        (1 << 2)
#define MPEG_GEN_SERIAL                          (1 << 3)
#define MPEG_GEN_BIT_REVERSE                     (1 << 4)
#define MPEG_GEN_ERR_ACK                         (1 << 5)
#define MPEG_GEN_SW_RESET                        (1 << 6)
#define MPEG_GEN_STAT_CLEAR                      (1 << 7)
#define CX23885_MPEG_GEN_DREQ_POL                (1 << 8)

#define CX23885_VIDEO_B_REG_BAD_PACKET_STAT      0x13015C
#define CX23885_VIDEO_C_REG_BAD_PACKET_STAT      0x13025C
#define CX23880_MPEG_REG_BAD_PACKET_STAT         0x33C054
#define MPEG_BAD_PACKET_ENABLE                   (1 << 12)
#define MPEG_BAD_PACKET_COUNT                    0xFFF,0

#define CX23885_VIDEO_B_REG_SOP_STATUS           0x130160
#define CX23885_VIDEO_C_REG_SOP_STATUS           0x130260
#define CX23880_MPEG_REG_SOP_STATUS              0x33C058
#define MPEG_SOP_POLARITY_HIGH                   (1 << 16)
#define MPEG_SOP_FORMAT                          3,14
#define MPEG_SOP_FMT_RISE                        0
#define MPEG_SOP_FMT_VALERR_RISE                 1
#define MPEG_SOP_FMT_RISE_FALL                   2
#define MPEG_SOP_FMT_START_BYTE                  3
#define MPEG_SOP_BYTEWIDE                        (1 << 13)
#define MPEG_SOP_ERR_CHECK                       (1 << 12)
#define MPEG_SOP_ERR_COUNT                       0xFFF,0

#define CX23885_VIDEO_B_REG_FIFO_STATUS          0x130164
#define CX23885_VIDEO_C_REG_FIFO_STATUS          0x130264
#define CX23880_MPEG_REG_FIFO_STATUS             0x33C05C
#define MPEG_FIFO_OVERFLOW_INTR                  (1 << 12)
#define MPEG_FIFO_OVERFLOW_COUNT                 0xFFF,0

#define CX23885_VIDEO_B_REG_MISCELLANEOUS        0x130168
#define CX23885_VIDEO_C_REG_MISCELLANEOUS        0x130268
#define CX23880_MPEG_REG_MISCELLANEOUS           0x33C060
#define MPEG_VALERR_POLARITY_LOW                 (1 << 13)
#define MPEG_VALERR_INTERNAL                     (1 << 12)
#define MPEG_VALID_LENGTH                        0xFFF,0

#define CX23885_VIDEO_B_REG_INT_MASK             0x040030
#define CX23885_VIDEO_B_REG_INT_STAT             0x040034
#define CX23885_VIDEO_B_REG_INT_MSTAT            0x040038
#define CX23885_VIDEO_B_REG_INT_SSTAT            0x04003C
#define CX23885_VIDEO_C_REG_INT_MASK             0x040040
#define CX23885_VIDEO_C_REG_INT_STAT             0x040044
#define CX23885_VIDEO_C_REG_INT_MSTAT            0x040048
#define CX23885_VIDEO_C_REG_INT_SSTAT            0x04004C
#define CX23880_MPEG_REG_INT_MASK                0x200070
#define CX23880_MPEG_REG_INT_STAT                0x200074
#define CX23880_MPEG_REG_INT_MSTAT               0x200078
#define CX23880_MPEG_REG_INT_SSTAT               0x20007C
#define MPEG_INT_BAD_PACKET                      (1 << 20)
#define MPEG_INT_PCI_ABORT                       (1 << 19)
#define MPEG_INT_RIP_ERR                         (1 << 18)
#define MPEG_INT_PAR_ERR                         (1 << 17)
#define MPEG_INT_OPCODE_ERR                      (1 << 16)
#define MPEG_INT_SYNC                            (1 << 12)
#define MPEG_INT_OVERFLOW                        (1 << 8)
#define MPEG_INT_RISCI2                          (1 << 4)
#define MPEG_INT_RISCI1                          (1 << 0)

#define CX23885_VIDEO_B_REG_SOURCE_SELECT        0x130144
#define CX23885_VIDEO_B_SRC_SEL_TS               1
#define CX23885_VIDEO_B_SRC_SEL_BT656            0

#define CX23885_VIDEO_B_REG_TS_CLOCK             0x13016C
#define CX23885_VIDEO_C_REG_TS_CLOCK             0x13026C
#define CX23885_VIDEO_TS_CLOCK_ENABLE            1
#define CX23885_VIDEO_TS_CLOCK_DISABLE           0

#endif
